% FingerprintGUI.m 

clear all
close all

FPGui = figure('Name','Fingerprint Recognition',...
   'NumberTitle','on',...
   'Color','black');

AxesHandle1 = axes('Position',[0.15 0.55 0.17 0.37],...
   'Box','on');

AxesHandle2 = axes('Position',[0.37 0.55 0.17 0.37],...
   'Box','on');

AxesHandle3 = axes('Position',[0.59 0.55 0.17 0.37],...
   'Box','on');

AxesHandle4 = axes('Position',[0.81 0.55 0.17 0.37],...
   'Box','on');

AxesHandle5 = axes('Position',[0.15 0.1 0.17 0.37],...
   'Box','on');

AxesHandle6 = axes('Position',[0.37 0.1 0.17 0.37],...
   'Box','on');

AxesHandle7 = axes('Position',[0.59 0.1 0.17 0.37],...
   'Box','on');

AxesHandle8 = axes('Position',[0.81 0.1 0.17 0.37],...
   'Box','on');

FrameBox = uicontrol(FPGui,...
   'Units','normalized', ...
   'Style','frame',...
   'BackgroundColor', 'black',...
   'ForegroundColor', 'black',...
	'Position',[0 0 0.15 1]);

title_load ='Fingerprint Image';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,350,80,20],...
   'String','Load Image',...
   'Callback',...
   ['image1=loadimage;'...
    'subplot(AxesHandle1);'...
    'imagesc(image1);'...
    'title(title_load, ''Color'', ''w'');'...
	 'colormap(gray);']);


 f = image_enhancement 
     
text_eq='Normalization';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,300,80,20],...
   'String','his-Equalization',...
   'Callback',...
   ['subplot(AxesHandle2);image1=f.normalization(image1);title(text_eq,''Color'', ''w'');']);


text_fft='FFT';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,280,80,20],...
   'String','fft',...
   'Callback',...
   ['subplot(AxesHandle3);image1=f.fftenhance(image1,0.45);imagesc(image1);title(text_fft,''Color'', ''w'');']);

     
text21='Binarization';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,260,80,20],...
   'String','Binarization',...
   'Callback',...
   ['subplot(AxesHandle4);'...
      'image1=f.adaptiveThres(double(image1),32);title(text21, ''Color'', ''w'');']);
     
text_filterArea='Orientation Flow Estimate';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
	'Position',[0,240,80,20],...   
	'String','Direction',...
	'Callback',...
   ['subplot(AxesHandle5);[o1Bound,o1Area]=f.direction(image1,16);title(text_filterArea,''Color'', ''w'');']);

     
text_ROI='Segmentation';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
	'Position',[0,220,80,20],...   
	'String','ROI Area',...
	'Callback',...
   ['subplot(AxesHandle6);[o2,o1Bound,o1Area]=f.drawROI(image1,o1Bound,o1Area);title(text_ROI,''Color'', ''w'');']);
      
text31='Thinning';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,200,80,20],...
   'String','Thining',...
   'Callback',...
   ['subplot(AxesHandle7);o1=f.thinning(o2);imagesc(o1,[0,1]);title(text31,''Color'', ''w'');']);
     
text41='Remove H breaks';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,180,80,20],...
   'String','remove H breaks',...
	'Callback',...
   ['subplot(AxesHandle8);o1=im2double(bwmorph(o1,''clean''));o1=im2double(bwmorph(o1,''hbreak''));imagesc(o1,[0,1]);title(text41,''Color'', ''w'');']);


textn1='remove spike';
h=uicontrol(FPGui,...
   'Style','pushbutton',...
   'Position',[0,160,80,20],...
   'String','Removing spike',...
   'Callback',...
   ['subplot(AxesHandle8);o1=im2double(bwmorph(o1,''spur''));imagesc(o1,[0,1]);title(textn1,''Color'', ''w'');']);

FPGui2 = figure('Name','Fingerprint Recognition',...
   'NumberTitle','on',...
   'Color','black');

FrameBox = uicontrol(FPGui2,...
   'Units','normalized', ...
   'Style','frame',...
   'BackgroundColor', 'black',...
   'ForegroundColor', 'black',...
	'Position',[0 0 0.15 1]);
   
AxesHandle2_1 = axes('Position',[0.2 0.15 0.35 0.7],...
   'Box','on');

AxesHandle2_2 = axes('Position',[0.6 0.15 0.35 0.7],...
   'Box','on');

g = minutiae_extraction

text51='Minutia Extract';
h=uicontrol(FPGui2,...
   'Style','pushbutton',...
	'Position',[0,280,80,20],...  
	'String','Extract',...
	'Callback',...
   ['[end_list1,branch_list1,ridgeMap1,edgeWidth]=g.mark_minutia(o1,o1Bound,o1Area,16);'...
	'subplot(AxesHandle2_1);g.show_minutia(o1,end_list1,branch_list1);title(text51, ''Color'', ''w'');']);
%Process for removing spurious minutia
text61='Remove spurious minutia';
h=uicontrol(FPGui2,...
   'Style','pushbutton',...
   'Position',[0,260,80,20],...
	'String','Real Minutiae',...
   'Callback',...
   ['[pathMap1,real_end1,real_branch1]=g.remove_spurious_minutia(o1,end_list1,branch_list1,o1Area,ridgeMap1,edgeWidth);'...
   'subplot(AxesHandle2_2);g.show_minutia(o1,real_end1,real_branch1);title(text61, ''Color'', ''w'');']);

%save template file, including the minutia position,direction,and ridge information
textSaveName='file name';
h=uicontrol(FPGui2,...
   'Style','pushbutton',...
	'Position',[0,240,80,20],...
	'String','save',...
   'Callback',...
   ['W=inputdlg(textSaveName);W=char(W);'...
    'save(W,''real_end1'',''pathMap1'',''-ASCII'');']);

mm = match_minutiae

%invoke template file loader and do matching
h=uicontrol('Style','pushbutton',...
   'String','Match',...
	'Position',[0,220,80,20],...
	'Callback',...
   ['finger1=fingerTemplateRead;'...
    'finger2=fingerTemplateRead;'...
    'percent_match=mm.match_end(finger1,finger2,10);']);
   