
function f = minutiae_extraction
f.mark_minutia = @mark_minutia;
f.show_minutia = @show_minutia;
f.remove_spurious_minutia = @remove_spurious_minutia;
f.interRidgeWidth = @interRidgeWidth;
f.getLocalTheta = @getLocalTheta


function [end_list,branch_list,ridgeOrderMap,edgeWidth] = mark_minutia(in, inBound,inArea,block);
[w,h] = size(in);
[ridgeOrderMap,totalRidgeNum] = bwlabel(in); 
imageBound = inBound;
imageArea = inArea;
blkSize = block;
edgeWidth = interRidgeWidth(in,inArea,blkSize);
end_list    = [];
branch_list = [];
for n=1:totalRidgeNum
   [m,n] = find(ridgeOrderMap==n);
   b = [m,n];
   ridgeW = size(b,1);
   for x = 1:ridgeW
      i = b(x,1);
      j = b(x,2);
      if inArea(ceil(i/blkSize),ceil(j/blkSize)) == 1          
          neiborNum = 0;
          neiborNum = sum(sum(in(i-1:i+1,j-1:j+1)));
          neiborNum = neiborNum -1;
          if neiborNum == 1 
              end_list =[end_list; [i,j]];
          elseif neiborNum == 3
              %if two neighbors among the three are connected directly
              %there may be three braches are counted in the nearing three cells
              tmp=in(i-1:i+1,j-1:j+1);
              tmp(2,2)=0;
              [abr,bbr]=find(tmp==1);
              t=[abr,bbr];
              if isempty(branch_list)
                  branch_list = [branch_list;[i,j]];
              else
                  for p=1:3
                      cbr=find(branch_list(:,1)==(abr(p)-2+i) & branch_list(:,2)==(bbr(p)-2+j) );
                      if ~isempty(cbr)
                          p=4;
                          break;
                      end;
                  end;
                  if p==3
                      branch_list = [branch_list;[i,j]];
                  end;
              end;
          end;	
      end;
   end;
end;

function [pathMap, final_end,final_branch] =remove_spurious_minutia(in,end_list,branch_list,inArea,ridgeOrderMap,edgeWidth)
[w,h] = size(in);
final_end = [];
final_branch =[];
direct = [];
pathMap = [];
end_list(:,3) = 0;
branch_list(:,3) = 1;
minutiaeList = [end_list;branch_list];
finalList = minutiaeList;
[numberOfMinutia,dummy] = size(minutiaeList);
suspectMinList = [];
for i= 1:numberOfMinutia-1
   for j = i+1:numberOfMinutia
      d =( (minutiaeList(i,1) - minutiaeList(j,1))^2 + (minutiaeList(i,2)-minutiaeList(j,2))^2)^0.5;
      if d < edgeWidth
         suspectMinList =[suspectMinList;[i,j]];
      end;
   end;
end;
[totalSuspectMin,dummy] = size(suspectMinList);
minutiaeList;
for k = 1:totalSuspectMin
   typesum = minutiaeList(suspectMinList(k,1),3) + minutiaeList(suspectMinList(k,2),3);
   if typesum == 1
      % branch - end pair
      if ridgeOrderMap(minutiaeList(suspectMinList(k,1),1),minutiaeList(suspectMinList(k,1),2) ) ==  ridgeOrderMap(minutiaeList(suspectMinList(k,2),1),minutiaeList(suspectMinList(k,2),2) )
         finalList(suspectMinList(k,1),1:2) = [-1,-1];
	      finalList(suspectMinList(k,2),1:2) = [-1,-1];
      end;
   elseif typesum == 2
      % branch - branch pair
      if ridgeOrderMap(minutiaeList(suspectMinList(k,1),1),minutiaeList(suspectMinList(k,1),2) ) ==  ridgeOrderMap(minutiaeList(suspectMinList(k,2),1),minutiaeList(suspectMinList(k,2),2) )
         finalList(suspectMinList(k,1),1:2) = [-1,-1];
	      finalList(suspectMinList(k,2),1:2) = [-1,-1];
      end;
   elseif typesum == 0
      % end - end pair
      a = minutiaeList(suspectMinList(k,1),1:3);
      b = minutiaeList(suspectMinList(k,2),1:3);
      if ridgeOrderMap(a(1),a(2)) ~=  ridgeOrderMap(b(1),b(2))
         [thetaA,pathA,dd,mm] = getLocalTheta(in,a,edgeWidth); 
         [thetaB,pathB,dd,mm] = getLocalTheta(in,b,edgeWidth); 
         %the connected line between the two points
         thetaC = atan2( (pathA(1,1)-pathB(1,1)), (pathA(1,2) - pathB(1,2)) );
         angleAB = abs(thetaA-thetaB);
         angleAC = abs(thetaA-thetaC);
         if ( (or(angleAB < pi/3, abs(angleAB -pi)<pi/3 )) & (or(angleAC < pi/3, abs(angleAC - pi) < pi/3)) )  
            finalList(suspectMinList(k,1),1:2) = [-1,-1];
            finalList(suspectMinList(k,2),1:2) = [-1,-1];
         end;
      %remove short ridge later
      elseif  ridgeOrderMap(a(1),a(2)) ==  ridgeOrderMap(b(1),b(2))        
         finalList(suspectMinList(k,1),1:2) = [-1,-1];
         finalList(suspectMinList(k,2),1:2) = [-1,-1];
      end;
   end;
end;
for k =1:numberOfMinutia
    if finalList(k,1:2) ~= [-1,-1]
        if finalList(k,3) == 0
            [thetak,pathk,dd,mm] = getLocalTheta(in,finalList(k,:),edgeWidth);
            if size(pathk,1) >= edgeWidth
                final_end=[final_end;[finalList(k,1:2),thetak]];
                [id,dummy] = size(final_end);
                pathk(:,3) = id;
            	pathMap = [pathMap;pathk];
            end;
        else
            final_branch=[final_branch;finalList(k,1:2)];
            [thetak,path1,path2,path3] = getLocalTheta(in,finalList(k,:),edgeWidth);
            if size(path1,1)>=edgeWidth & size(path2,1)>=edgeWidth & size(path3,1)>=edgeWidth
            final_end=[final_end;[path1(1,1:2),thetak(1)]];
            [id,dummy] = size(final_end);
            path1(:,3) = id;
            pathMap = [pathMap;path1];
            final_end=[final_end;[path2(1,1:2),thetak(2)]];
            path2(:,3) = id+1;
            pathMap = [pathMap;path2];
            final_end=[final_end;[path3(1,1:2),thetak(3)]];
    		path3(:,3) = id+2;
            pathMap = [pathMap;path3];
            end;
        end;
    end;
end;
       
function show_minutia(image,end_list,branch_list);
colormap(gray);imagesc(image);
hold on;
if ~isempty(end_list)
    plot(end_list(:,2),end_list(:,1),'*r');
    if size(end_list,2) == 3
        hold on
        [u,v] = pol2cart(end_list(:,3),10);
        quiver(end_list(:,2),end_list(:,1),u,v,0,'g');
    end;
end;
if ~isempty(branch_list)
    hold on
    plot(branch_list(:,2),branch_list(:,1),'+y');
end;


function edgeDistance = interRidgeWidth(image,inROI,blocksize)
[w,h] = size(image);
a=sum(inROI);
b=find(a>0);
c=min(b);
d=max(b);
i=round(w/5);
m=0;
for k=1:4
   m=m+sum(image(k*i,16*c:16*d));
end;
e=(64*(d-c))/m;
a=sum(inROI,2);
b=find(a>0);
c=min(b);
d=max(b);
i=round(h/5);
m=0;
for k=1:4
   m=m+sum(image(16*c:16*d,k*i));
end;
m=(64*(d-c))/m;
edgeDistance=round((m+e)/2);

   


function [theta,paths1,paths2,paths3] = getLocalTheta(in,start_point,edgeWidth)
paths1 =[];
paths2 =[];
paths3 =[];
a = start_point;
pathA = [];
pathA = a(1,1:2);   
theta = [];
if a(3) == 0
    for p=1:edgeWidth
        [cur,dummy] = size(pathA);
        i = pathA(cur,1);
        j = pathA(cur,2);
        window=in(i-1:i+1,j-1:j+1);
        window(2,2) = 0;
        if cur > 1
            window( 2 - pathA(cur,1) + pathA(cur-1,1) , 2- pathA(cur,2) + pathA(cur-1,2) ) = 0;
        end;
        [q,r]=find(window);
        b=[q,r];
        [neighbors,dummy]=size(b);
        if neighbors == 1
            pathA(cur+1,1) = b(1,1)-2 + pathA(cur,1);
            pathA(cur+1,2) = b(1,2)-2 + pathA(cur,2);
        else
            break;
        end;
    end;
    [path_length, dddd] = size(pathA);			
    paths1 = pathA;
    mean_x = 0;
    mean_y = 0;
    mean_value = sum(pathA);
    mean_x = mean_value(1) / path_length;
    mean_y = mean_value(2) / path_length;
    theta = atan2( (mean_x - pathA(1,1)),(mean_y - pathA(1,2)) );
elseif a(3) == 1
    pathA = [];
    total_mx = 0;
    total_my = 0;
    i = a(1);
    j = a(2);
    pathA(1,:) = [i,j];
    window=in(i-1:i+1,j-1:j+1);
    window(2,2) = 0;
    [q,r]=find(window);
    b=[q,r];
    [neighbors,dummy]=size(b);
    if neighbors == 3
        for s = 1:3
            pathA(2,1) = b(s,1)-2 + pathA(1,1);
            pathA(2,2) = b(s,2)-2 + pathA(1,2);
            for p = 1:edgeWidth
                [cur,dummy] = size(pathA);
                i = pathA(cur,1);
                j = pathA(cur,2);
                window=in(i-1:i+1,j-1:j+1);            
                window(2,2) = 0;
                if cur > 1
                    window( 2 - pathA(cur,1) + pathA(cur-1,1) , 2- pathA(cur,2) + pathA(cur-1,2) ) = 0;
                end;
                [q,r]=find(window);
                c=[q,r];
                [neighbors,dummy]=size(c);
                if neighbors == 1
                    pathA(cur+1,1) = c(1,1)-2 + pathA(cur,1);
                    pathA(cur+1,2) = c(1,2)-2 + pathA(cur,2);
                else
                    break;
                end;
            end;
            [path_length, dddd] = size(pathA);			
	    	mean_x = 0;
			mean_y = 0;
            mean_value = sum(pathA);
            mean_x = mean_value(1) / path_length;
			mean_y = mean_value(2) / path_length;
            theta = [theta;atan2( (mean_x - pathA(1,1)),(mean_y - pathA(1,2)) )];
            if s == 1
                paths1 = pathA(2:path_length,:);
            elseif s == 2
                paths2 = pathA(2:path_length,:);
            elseif s == 3
                paths3 = pathA(2:path_length,:);
            end;
            pathA(2:path_length,:) = [];
        end;
    end;
end;



            
            




	
         
